<?php
/*
Copyright (C) 2009 Anja S. Gritz <http://www.goeritz.net>
This file is part of phpPanelAdmin.

phpPanelAdmin is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
any later version.

phpPanelAdmin is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with phpPanelAdmin. If not, see <http://www.gnu.org/licenses/>.
*/

session_start();
if(!isset($_SESSION['admin']))
{
echo "Processing impossible!<br>";
echo "<a href=\"index.php\">Login?</a>";
}

//cookie is there
else
{
?>
<html><head><title>Dynamic Page</title>
<script language="JavaScript" type="text/JavaScript">
<!--
function CheckAll()
{
	for (var i=0;i<document.alter.elements.length;i++)
	{
 	if(document.alter.elements[i].name != 'ALL') document.alter.elements[i].checked = document.alter.ALL.checked;
 	}
}

 function Confirm1()
{
if (confirm("If you press ok, the checked person(s) will be deleted."))
	return true ;
else
	return false ;
}
//-->
</script>
</head><body>
<?php
require 'header.php';

	//"Delete Variables" was requested in search.php
	if (isset($_POST['toolbutton_delete_columns']))
	{
	echo "<h1>Delete Variable(s)</h1>";
		$count=0;

		foreach($_POST as $name=>$value)
		{
			//it is a checkbox for a column
			if ($value == "delete")
			{
			//delete from $db_table
			$sql = "ALTER TABLE $db_table DROP COLUMN $name";
			$result = mysqli_query($link, $sql) or die ("<br>Unable to delete \"$name\" from $db_table. ".mysqli_error($link));

			/* delete from $db_table_deleted; do not throw error because field might not be present in $db_table_deleted */
			$sql = "ALTER TABLE $db_table_deleted DROP COLUMN $name";
			$result = mysqli_query($link, $sql);

			//increment counter
			$count++;
			}
		}

		//no variable was selected for deletion
		if ($count==0)
		{
		echo "You did not select any variable to be deleted.";
		}
		//variable was selected for deletion
		else
		{
		echo "$count variable(s) was/were successfully deleted.";
		}

	//display to everybody
	echo "<br><br><a href=\"search.php\">back to search</a>";
	}


	/* Delete Person(s) was requested in search.php or reasons were already submitted */
	elseif ((isset($_POST['toolbutton_delete_rows'])) OR (isset($_POST['toolbutton_submit_reasons'])))
	{
		if (isset($_POST['toolbutton_delete_rows']))
		{
		echo "<h1>Delete Person(s)</h1>";
		$count=0;

		//compose WHERE condition of search query
		$sql2 = " WHERE ";

			foreach($_POST as $name=>$value)
			{
				//$name starts with "id_"
				if (preg_match("#^id_#i", $name))
				{
				$sql2 .= "id=$value OR ";
				//increment counter for # of people to be deleted
				$count++;
				}
			}

			//end part of WHERE condition
			$sql2 .= "id<0";

			//no person was selected for deletion
			if ($count==0)
			{
			echo "You did not select any person to be deleted.";
			echo "<br><br><a href=\"javascript:history.back()\">back</a>";
			}

			/* at least one person was selected for deletion */
			else
			{
			//display form to enter reason for deletion
			?>
			 Please choose or enter a reason for the deletion: <form action="<?php echo $_SERVER['PHP_SELF'] ?>" method="post" name="delete_reason">
			 <input name="sql2" type="hidden" value="<?php echo "$sql2"; ?>">
			 <input name="count" type="hidden" value="<?php echo "$count"; ?>">
			 <input type="radio" name="del_reason" value="undeliverable"> e-mail address invalid<br>
			 <input type="radio" name="del_reason" value="duplicate"> person already in panel<br>
			 <input type="radio" name="del_reason" value="request" checked> person wishes to be deleted<br>
			 <input type="radio" name="del_reason" value="ineligible"> person ineligible to be in panel<br><br>
			 You may enter additional information about the reason:<br>
			 <textarea name="del_reason2" cols="38" rows="2"></textarea><br><br>
			 <input name="toolbutton_submit_reasons" type="submit" title="Submit Reasons Form" value="Submit"></form>
			<?php
			}
		}

		/* form with reasons was submitted, next: process deletion */
		else
		{
		/* determine names and types of fields in db */
		$sql = "SHOW FIELDS FROM $db_table";
		$result = mysqli_query($link, $sql) or die ('Unable to Select from DB3');
		$fieldnames = "";
			//traverse fields
			for ($d = 0; $d < mysqli_num_rows($result); $d++)
			{
			$row = mysqli_fetch_assoc($result);
			$fieldnames .= "$row[Field]";
				//add comma until penultimate fieldname
				if ($d < mysqli_num_rows($result)-1)
				{
				$fieldnames .= ",";
				}

			/* create field in $db_table_deleted, in case it might not be there; do not throw error because field might already be present in $db_table_deleted */
			$sql5 ="ALTER TABLE $db_table_deleted ADD $row[Field] $row[Type]";
			mysqli_query ($link, $sql5);
			}

		/* relocate person(s) into $db_table_deleted */
		$sql3 = "INSERT INTO $db_table_deleted ($fieldnames) SELECT $fieldnames FROM $db_table $_POST[sql2]";
		mysqli_query($link, $sql3) or die( "Unable to read from or insert into table! ".mysqli_error($link));

		/* include del_date, del_time, and del_reason in $db_table_deleted */
		mysqli_query($link, "UPDATE $db_table_deleted SET del_date = '".date('Y-m-d')."', del_time = '".date('G:i:s')."', del_reason= '[admin] ".$_POST['del_reason']." ".$_POST['del_reason2']."' $_POST[sql2]");

		/* delete person(s) from $db_table */
		$sql4 = "DELETE FROM $db_table $_POST[sql2]";
		$result = mysqli_query($link, $sql4) or die ("<br>Unable to delete from Table $db_table. ".mysqli_error($link));

		echo "<h1>Delete Person(s)</h1>";
		echo "The selected ".$_POST['count']." person(s) was/were successfully deleted.";
		echo "<br><br><a href=\"search.php\">back to search</a>";
		}
	}

	//view & alter was requested in search.php
	elseif (isset($_POST['toolbutton_view_and_alter']))
	{
	echo "<h1>View & Alter</h1>";

	//compose WHERE condition of search query
	$sql2 = " WHERE ";
	$count=0;
		foreach($_POST as $name=>$value)
		{
			//$name starts with "id_"
			if (preg_match("#^id_#i", $name))
			{
			$sql2 .= "id=$value OR ";
			/* increment counter for # of people to be viewed */
			$count++;
			}
		}
	//end part of WHERE condition
	$sql2 .= "id<0";

		/* no person was selected for viewing and altering */
		if ($count==0)
		{
		echo "You did not select any person to be viewed and altered.";
		echo "<br><br><a href=\"javascript:history.back()\">back</a>";
		}

		/* at least one person was selected for viewing and altering */
		else
		{

		if (isset($_POST['order_info'])) {$order_info = $_POST['order_info'];} else {$order_info="";}

		//compose db query
		$sql6 = "SELECT * FROM $db_table $sql2 $order_info";
		//echo "$sql6";
		$result = mysqli_query($link, $sql6) or die ("Unable to Select from DB5 ".mysqli_error($link));

		echo "<form action=\"$_SERVER[PHP_SELF]\" method=\"post\" name=\"alter\"><table border=\"1\"><tr><th></th>";

			/* get the field names and write them in first row of a table
			as often as there are different fields */
			for ($c = 0; $c < mysqli_field_count($link); $c++)
			{
			$finfo = mysqli_fetch_field_direct($result, $c);
			echo "<th align=\"left\" nowrap>".$finfo->name."</th>";
			}

		echo "</tr><tr>";

			/* as long as there are rows in the result array */
			for ($e = 0; $e < mysqli_num_rows($result); $e++)
			{
			$ergebnis = mysqli_fetch_assoc ($result);
			echo "<td><input name=\"id_".$e."\" type=\"checkbox\" value=\"".$ergebnis['id']."\" checked></td>";

				/* as long as there are fields in the result array get data and write them in table */
				for ($f = 0; $f < mysqli_field_count($link); $f++)
				{
				echo "<td>";

					/* write inside a textarea only if column unequal "id" */
					$finfo = mysqli_fetch_field_direct($result, $f);
					if ($finfo->name != "id")
						{
						echo "<textarea name=\"".$ergebnis['id']."_".$finfo->name."\" cols=\"15\" rows=\"2\" wrap=\"on\">".$ergebnis[$finfo->name]."</textarea>";
						}
					else
						{
						echo $ergebnis[$finfo->name];
						}
				echo "</td>";
				}
			echo "</tr>";
			}
		echo "</table><input name=\"ALL\" type=\"CHECKBOX\" value=\"CHECK ALL\" onClick=\"CheckAll();\" checked>
		(un-)select all $e panelists<br><br><input type=\"submit\" value=\"Save Modifications\" name=\"toolbutton_alter\" title=\"Submit alter form\" style=\"width:130px\">
		<input type=\"submit\" value=\"Delete Person(s)\" name=\"toolbutton_delete_rows\" title=\"Submit Delete Person(s) form\" onClick=\"return Confirm1();\" style=\"width:132px\"> </form>";
		}
	}

	/* "save modifications" was requested in select.php */
	elseif (isset($_POST['toolbutton_alter']))
	{
		$count=0;
		foreach($_POST as $name=>$value)
		{
			//$name starts with "id_"
			if (preg_match("#^id_#i", $name))
			{
				foreach($_POST as $name2=>$value2)
				{
					//$name2 starts with "$value_"
					//if (eregi("^".$value."_", $name2))
					if (preg_match("#^".$value."_#i", $name2))
					{
          $searchpattern = "".$value."_";

          $name2 = preg_replace("#^$searchpattern#i", "", $name2, 1);
					mysqli_query($link, "UPDATE $db_table SET $name2='$value2' WHERE id=$value") or die( "Unable to update table");
					}
				}
			//increment counter for # of people to be modified
			$count++;
			}
		}

			/* no person was selected for modification	 */
			if ($count==0)
			{
			echo "<br><br>You did not select any person to be modified.";
			echo "<br><br><a href=\"javascript:history.back()\">back</a>";
			}

			/* at least one person was selected for modification */
			else
			{
			echo "<br><br>The selected person(s) was/were succesfully modified.";
			echo "<br><br><a href=\"search.php\">back to search</a>";
			}
	}

	/* "export" was requested in search.php */
	elseif (isset($_POST['toolbutton_export']))
	{

	echo "<h1>Export</h1>";
	//initialize empty vars
	$sql_fields = '';
	$count=0;

	/* compose fields of select query */
	foreach($_POST as $name=>$value)
	{
		//it is a checkbox for a column
		if ($value == "delete")
		{
		//delete from $db_table
		$sql_fields .= "$name, ";

		//increment counter
		$count++;
		}
	}
	$sql_fields .= 'id';


	/* compose WHERE condition of select query */
	$sql2 = " WHERE ";

		foreach($_POST as $name=>$value)
		{
			//$name starts with "id_"
			if (preg_match("#^id_#i", $name))
			{
			$sql2 .= "id=$value OR ";
			/* increment counter for # of people to be exported */
			$count++;
			}
		}
		//end part of WHERE condition
		$sql2 .= "id<0";

			//no person was selected for export
			if ($count==0)
			{
			echo "You did not select any data to be exported.";
			echo "<br><br><a href=\"javascript:history.back()\">back</a>";
			}
			//at least one person was selected for export
			else
			{
			echo "<form action=\"export.php\" method=\"post\" name=\"export_format\"><input name=\"sql_fields\" type=\"hidden\" value=\"$sql_fields\"><input name=\"sql2\" type=\"hidden\" value=\"$sql2\"><input name=\"order_info\" type=\"hidden\" value=\"$_POST[order_info]\">";
			echo "The export may take some time. Please be patient!";
			echo "<br><br>Choose the export format or return to search:<br><br><input type=\"submit\" value=\"MS Excel\" name=\"toolbutton_excel_export\" title=\"Submit excel format form\" style=\"width:130px\"> <input type=\"submit\" value=\"Tab-delimited\" name=\"toolbutton_tabulator_export\" title=\"Submit tab-delimited format form\" style=\"width:130px\"> <br><br><a href=\"search.php\"><input type=\"button\" value=\"Return to Search\" name=\"toolbutton_return\" title=\"Submit return form\" style=\"width:130px\"></a></form>";
			}
	}

	//"sampling" was requested in search.php
	elseif (isset($_POST['toolbutton_sampling']))
	{
	echo "<h1>Sampling</h1>";
	$count=0;
	//compose WHERE condition of search query
	$sql2 = " WHERE ";
		foreach($_POST as $name=>$value)
		{
			//$name starts with "id_"
			if (preg_match("#^id_#i", $name))
			{
			$sql2 .= "id=$value OR ";
			/* increase counter for # of people to be sampled */
			$count++;
			}
		}
	//end part of WHERE condition
	$sql2 .= "id<0";

		//no person was selected for sampling
		if (!$count)
		{
		echo "You did not select any person to be sampled.";
		echo "<br><br><a href=\"javascript:history.back()\">back</a>";
		}
		/* at least one person was selected for sampling */
		else
		{
		echo "<form action=\"sampling.php\" method=\"post\" name=\"sampling\"><input name=\"sql2\" type=\"hidden\" value=\"$sql2\"><input name=\"counted\" type=\"hidden\" value=\"$count\">";
		echo "Sample all panelists who were checked: <input type=\"submit\" value=\"All in Sample\" name=\"toolbutton_all_in_sample\" title=\"Submit All in Sample form\" style=\"width:130px\">";
		echo "<br><br>Sample this number from checked panelists: <input name=\"no_in_sample\" type=\"text\" size=\"6\"> <input type=\"submit\" value=\"Draw Sample\" name=\"toolbutton_draw_sample\" title=\"Submit Draw Sample form\" style=\"width:130px\">";
		echo "<br><br><br><a href=\"search.php\"><input type=\"button\" value=\"Return to Search\" name=\"toolbutton_return\" title=\"Submit return form\" style=\"width:130px\"></a></form>";
		}
	}

	//"E-Mail" was requested in search.php
	elseif (isset($_POST['toolbutton_email']))
	{
	echo "<h1>E-Mail</h1>";

	/* check whether email field exists in db */
	mysqli_query($link, "SELECT email FROM $db_table LIMIT 1") or die(mysqli_error()."<br>There does not exist a field called 'email' in the database. In case another field in the database contains the e-mail address this field needs to be renamed to 'email' to be able to send e-mail.<br><br><a href=\"search.php\">go to search</a> ");

	/* compose WHERE condition of search query */
	$sql2 = " WHERE ";
	$count=0;

		foreach($_POST as $name=>$value)
		{
			//$name starts with "id_"
			if (preg_match("#^id_#i", $name))
			{
			$sql2 .= "id=$value OR ";
			/* increment counter for # of people to be sent an e-mail */
			$count++;
			}
		}

	//end part of WHERE condition
	$sql2 .= "id<0";

		/* no person was selected for sending e-mail to */
		if (!$count)
		{
		echo "You did not select any person to sent an e-mail.";
		echo "<br><br><a href=\"javascript:history.back()\">back</a>";
		}
		/* at least one person was selected for being sent e-mail */
		else
		{
		echo "<form action=\"email.php\" method=\"post\" name=\"email\"><input name=\"sql2\" type=\"hidden\" value=\"$sql2\">";
		echo "You may choose an e-mail template:<br><br>";
		echo "<input name=\"template_select\" type=\"radio\" value=\"none\" checked> <i>--- No Template ---</i><br>";

		//list existing templates
		$result = mysqli_query($link, "SELECT name FROM $db_table_templates ORDER BY name ASC") or die ('Unable to Select from DB1');

			for ($c = 0; $c < mysqli_num_rows($result); $c++)
			{
			$ergebnis = mysqli_fetch_assoc($result);
			echo "<input name=\"template_select\" type=\"radio\" value=\"".$ergebnis['name']."\"> ".$ergebnis['name']."<br>";
			}

		echo "<br><input type=\"submit\" value=\"Compose E-Mail\" name=\"toolbutton_compose_email\" title=\"Submit Compose E-Mail form\" style=\"width:130px\"> ";
		echo "<a href=\"search.php\"><input type=\"button\" value=\"Return to Search\" name=\"toolbutton_return\" title=\"Submit return form\" style=\"width:130px\"></a></form>";
		}
	}

	//"Clone Variable" was requested in search.php
	elseif (isset($_POST['toolbutton_clone_column']))
	{
	echo "<h1>Clone Variable</h1>";
	$count=0;

		//find out how many columns were checked
		foreach($_POST as $name=>$value)
		{
			if ($value == "delete")
			{
			$column_for_cloning = $name;
			//increment counter
			$count++;
			}
		}

		//no variable was selected for cloning
		if ($count==0)
		{
		echo "You did not select a variable to be cloned.";
		echo "<br><br><a href=\"javascript:history.back()\">back</a>";
		}
		//more than one variable was selected for cloning
		elseif ($count > 1)
		{
		echo "You can select only one variable to be cloned at a time.";
		echo "<br><br><a href=\"javascript:history.back()\">back</a>";
		}
		/* one variable was selected for cloning, proceed */
		else
		{
		echo "<form action=\"$_SERVER[PHP_SELF]\" method=\"post\" name=\"cloning\"><input name=\"column_for_cloning\" type=\"hidden\" value=\"$column_for_cloning\">";
		echo "Name of clone variable: <br><input name=\"clone_name\" type=\"text\" value=\"\" size=\"40\"><br><br><br><input type=\"submit\" value=\"Proceed\" name=\"toolbutton_proceed_cloning\" title=\"Submit Proceed form\" style=\"width:130px\"> ";
		echo "<a href=\"search.php\"><input type=\"button\" value=\"Return to Search\" name=\"toolbutton_return\" title=\"Submit return form\" style=\"width:130px\"></a></form>";
		}
	}

	/* "Proceed Cloning" was requested in select.php */
	elseif (isset($_POST['toolbutton_proceed_cloning']))
	{
	echo "<h1>Clone Variable</h1>";

		//no variable name was entered
		if (empty($_POST['clone_name']))
		{
		echo "You need to set a name of the clone variable.";
		echo "<br><br><a href=\"javascript:history.back()\">back</a>";
		mysqli_close($link);
		exit;
		}

		//check whether new var name is valid
		if (!preg_match ('#^[a-zA-Z_][a-zA-Z0-9_]*$#', $_POST['clone_name']))
		{
		echo 'The variable name is invalid. A valid variable name starts with a letter or underscore, followed by any number of letters, numbers, or underscores, but no special characters and umlauts.';
		echo "<br><br><a href=\"javascript:history.back()\">back</a>";
		mysqli_close($link);
		exit;
		}

		//variable name was entered
		else
		{
		/* check whether variable name is unique
		get existing variable names from DB */
		$sql6 = "SELECT * FROM $db_table LIMIT 1";
		$result = mysqli_query($link, $sql6) or die ('Unable to Select from DB2');

			//as long as there are fields
			for ($d = 0; $d < mysqli_num_fields($result); $d++)
			{
			$info = mysqli_fetch_field_direct($result, $d);
				//duplicate exists
				if ($_POST['clone_name'] == "$info->name")
				{
				echo "Variable <b>$_POST[clone_name]</b> does already exist. <br>Please choose a unique variable name.";
				echo "<br><br><a href=\"javascript:history.back()\">back</a>";
				mysqli_close($link);
				exit;
				}
			}

		/* clone variable in DB
		get column specification for cloned variable  */
		$sql6 = "DESCRIBE $db_table $_POST[column_for_cloning]";
		$result = mysqli_query($link, $sql6) or die ("Unable to fetch column info for $_POST[column_for_cloning] ".mysqli_error($link));

			$ergebnis = mysqli_fetch_assoc($result);

			//compose parts for next sql query
			if ($ergebnis['Null'] != "YES")
			{
			$nullvar = "NOT NULL";
			}
			else
			{
			$nullvar = "";
			}

			if ($ergebnis['Default'] == "")
			{
			$defaultvar = "";
			}
			else
			{
			$defaultvar = "default '".$ergebnis['Default']."'";
			}

		/* create clone variable with the same columns specs as the cloned variable */
		$sql7 = "ALTER TABLE $db_table ADD $_POST[clone_name] ".$ergebnis['Type']." $nullvar $defaultvar ".$ergebnis['Extra'];
		$result = mysqli_query($link, $sql7) or die ("Unable to add new column $_POST[clone_name] ".mysqli_error($link));

		//write into clone variable
		$sql8 = "UPDATE $db_table SET $_POST[clone_name] = $_POST[column_for_cloning]";
		$result = mysqli_query($link, $sql8) or die ('Unable to Update DB '.mysqli_error($link));

		echo "Variable <b>$_POST[column_for_cloning]</b> was successfully cloned into <b>$_POST[clone_name]</b>.";
		echo "<br><br><a href=\"search.php\">back to search</a>";
		}
	}

mysqli_close($link);
}
?>
</body></html>