<?php
/*
Copyright (C) 2009 Anja S. Gritz <http://www.goeritz.net>
This file is part of phpPanelAdmin.

phpPanelAdmin is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
any later version.

phpPanelAdmin is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with phpPanelAdmin. If not, see <http://www.gnu.org/licenses/>.
*/
?>

<html><head><title>Unfold Databases</title></head><body><h1>Unfold Databases</h1>
<?php
//create db and tables with default users
include 'config_db.php';

//connect to db server
$link = mysqli_connect($db_host,$db_user,$db_password,$db_database) or die("Error: ".mysqli_error($link));
mysqli_query($link, "CREATE DATABASE IF NOT EXISTS $db_database") or die ("Unable to create database $db_database".mysqli_error($link));

mysqli_query($link, "CREATE TABLE IF NOT EXISTS $db_table (id int(9) NOT NULL auto_increment, PRIMARY KEY (id)) ENGINE=MyISAM") or die( "Unable to create table $db_table ".mysqli_error($link));
mysqli_query($link, "CREATE TABLE IF NOT EXISTS $db_table_deleted (id int(9) NOT NULL auto_increment, PRIMARY KEY (id), del_date DATE, del_time VARCHAR(8), del_reason VARCHAR(255)) ENGINE=MyISAM") or die ("Unable to create table $db_table_deleted ".mysqli_error($link));
mysqli_query($link, "CREATE TABLE IF NOT EXISTS $db_table_admins (id int(9) NOT NULL auto_increment, user VARCHAR(32), password VARCHAR(32), email_sender_name VARCHAR(150), email_sender_address VARCHAR(150), PRIMARY KEY (id)) ENGINE=MyISAM") or die ("Unable to create table $db_table_admins ".mysqli_error($link));
mysqli_query($link, "INSERT INTO $db_table_admins (user, password, email_sender_name, email_sender_address) VALUES ('$db_user', '".md5($db_password)."', '$email_sender_name', '$email_sender_address')") or die ("Unable to insert into table! ".mysqli_error($link)); //encrypt pw for db
mysqli_query($link, "CREATE TABLE IF NOT EXISTS $db_table_templates (id int(9) NOT NULL auto_increment, name VARCHAR(255), subject VARCHAR(255), body MEDIUMTEXT, PRIMARY KEY (id)) ENGINE=MyISAM") or die ("Unable to create table $db_table_templates ".mysqli_error($link));

//create five default e-mail templates
mysqli_query($link, "INSERT INTO $db_table_templates (name, subject, body) VALUES ('invitation to participate', '[Panel] Invitation', 'Hello ##first_name##, \n\nWe invite you to take part in a study about XXX. \nThe study is open until XXX. It takes approximately XXX min to fill out the questionnaire. \nTo access the study please click on the following link: \nhttp://www.XXXdomain.net/XXXstudy.htm?code=##reg_urlcode## \n\nKind regards, \nThe Panel Team\n')") or die( "Unable to insert mail template1 into table!");
mysqli_query($link, "INSERT INTO $db_table_templates (name, subject, body) VALUES ('reminder to participate', '[Panel] Reminder', 'Hello ##first_name##, \n\nA few days ago we sent you an invitation to a study about XXX. We would appreciate if you could take part in this study. \nThe study is open until XXX. It takes approximately XXX min to fill out the questionnaire. \nTo access the study please click on the following link: \nhttp://www.XXXdomain.net/XXXstudy.htm?code=##reg_urlcode## \n\nKind regards, \nThe Panel Team\n ')") or die( "Unable to insert mail template2 into table!");
mysqli_query($link, "INSERT INTO $db_table_templates (name, subject, body) VALUES ('user data', '[Panel] Your data', 'Hello ##first_name##, \n\nYou have requested your login data. You are registered with e-mail-address ##email## in our system. \n\nBest wishes,\nThe Panel Team\n ')") or die( "Unable to insert mail template3 into table!");
mysqli_query($link, "INSERT INTO $db_table_templates (name, subject, body) VALUES ('confirmation of deletion', '[Panel] Confirmation', 'Hello ##first_name##, \n\nWe have deleted your profile from our system. Thank you for having participated. \n\nKind regards,\nThe Panel Team\n ')") or die( "Unable to insert mail template4 into table!");
mysqli_query($link, "INSERT INTO $db_table_templates (name, subject, body) VALUES ('opt-out snippet', '[Panel] Quit Membership', 'Hello ##first_name##, \n\nIf you want to permanently quit your membership in the panel click this link: \nhttp://www.XXXdomain.net/XXXsignup.php?code=##reg_urlcode##&id=##id## \n\nThank you for having been a member. \n\nKind regards,\nThe Panel Team\n ')") or die( "Unable to insert mail template5 into table!");

mysqli_close($link);
echo "Databases were succesfully created.<br><br>For security reasons, you should now delete the file <b>$_SERVER[PHP_SELF]</b> from the Web-enabled folder of your server <b>$_SERVER[SERVER_NAME]</b>.";
?>
</body></html>
