<?php
/*
Copyright (C) 2009 Anja S. Gritz <http://www.goeritz.net>
This file is part of phpPanelAdmin.

phpPanelAdmin is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
any later version.

phpPanelAdmin is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with phpPanelAdmin. If not, see <http://www.gnu.org/licenses/>.
*/

session_start();
if(!isset($_SESSION['admin']))
{
echo "Processing impossible!<br>";
echo "<a href=\"index.php\">Login?</a>";
}
//cookie is there
else
{

?>
<html><head><title>SQL Query</title>
<script language="JavaScript" type="text/JavaScript">
<!--
 function Confirm1()
{
var agree=confirm("If you press ok, any changes to the tables are irreversible!");
if (agree)
	return true ;
else
	return false ;
}

 function popUp(URL)
{
day = new Date();
id = day.getTime();
eval("page" + id + " = window.open(URL, '" + id + "', 'scrollbars=1,resizable=1,width=500,height=500,left=350,top=250');");
}

//-->
</script>
</head><body onLoad="document.sql_query.query.focus();">

<?php
require 'header.php';
?>
<h1>Query Database <a href="javascript:popUp('help.php#sql_query')" style="text-decoration:none; border-style:outset; border-width:2px; margin-left:30px; color:#666666; font-size:smaller;"> ? </a></h1>

<?php
	//query form has been submitted
	if (isset($_POST['toolbutton_sql_query']))
	{
		/* strip whitespaces from beginning and end of $_POST['query'] */
		$_POST['query'] = rtrim(ltrim($_POST['query']));

		//query is empty
		if ($_POST['query']=="")
		{
		echo "Your query is empty.";
		}

		//query contains forbidden commands (case insensitive)
		elseif (preg_match("#^drop|^create|^alter database|rename | drop id| drop column id| drop index| drop primary key#i", $_POST['query']))
		{
		echo "For security, this query is forbidden to be used via this interface.<br>";
		echo "This query might be blocked because by chance a variable name or variable value you have used in this query was identical to a reserved sql-statement.";
		echo "<br>If this is the case, try another variable name or value.";
		echo "<br>If this is not the case and you still want to execute this risky query you need to use another database interface.";
		}

		/* query is not empty and does not contain forbidden commands */
		else
		{
		//replace double quotes by single quotes
		$sql = str_replace('"','\'',$_POST['query']);
		eval("\$sql = \"$sql\";");
		$result = mysqli_query($link, $sql) or die ('Unable to execute query: '.mysqli_error($link));

			//query is succesful
			if ($result)
			{
			echo 'Your query has been executed.<br>'.mysqli_info($link).'<br>' ;

				/* $_POST['query'] starts with "select" (case insensitive), spit out result array */
				if (preg_match("#^select#i", $_POST['query'])==1)
				{
				echo "<table border=\"1\"><tr>";

				/* get the field names and write them in first row of a table
				as often as there are different fields */
				for ($c = 0; $c < mysqli_field_count($link); $c++)
					{
					$finfo = mysqli_fetch_field_direct($result, $c);
					echo "<th align=\"left\" nowrap>".$finfo->name."</th>";
					}
				echo "</tr><tr>";

				/* as long as there are rows in the result array */
				for ($e = 0; $e < mysqli_num_rows($result); $e++)
					{
					$ergebnis = mysqli_fetch_row ($result);
					/* as long as there are fields in the result array get data and write them in table */
					for ($f = 0; $f < mysqli_field_count($link); $f++)
						{
						echo "<td>".$ergebnis[$f]."</td>";
						}
					echo "</tr>";
					}
				echo "</table>";
				}
			}

		mysqli_close($link);
		}
	echo "<br><br><a href=\"javascript:history.back()\">back</a>";
	}

	/* query form has not been submitted, show form */
	else
	{

	?>
	If you know what you are doing you can query the database directly by entering an SQL statement in the text area.
	<br>To query the profile data table use &quot;$db_table&quot;, to query the table that contains panel administrators use
	&quot;$db_table_admins&quot;, to query the table that contains deleted panelists use &quot;$db_table_deleted&quot;.
	<br><br>
	<form action="<?php echo $_SERVER['PHP_SELF']?>" method="post" name="sql_query">
	<textarea name="query" cols="50" rows="6"></textarea><br><br><input name="toolbutton_sql_query" type="submit" value="Send query" title="Submit query form" style="width:130px">
	</form>

	<?php
	}
}
?>
</body></html>